Index: library/doc/html/exp__family_8h_source.html
===================================================================
--- library/doc/html/exp__family_8h_source.html (revision 656)
+++ library/doc/html/exp__family_8h_source.html (revision 661)
@@ -302,5 +302,5 @@
 <a name="l00366"></a>00366         <span class="keyword">public</span>:
 <a name="l00367"></a>00367                 <a class="code" href="classbdm_1_1mDirich.html">mDirich</a>(): <a class="code" href="classbdm_1_1mpdf__internal.html" title="Mpdf with internal epdf that is modified by function condition.">mpdf_internal</a>&lt;<a class="code" href="classbdm_1_1eDirich.html" title="Dirichlet posterior density.">eDirich</a>&gt;(), <a class="code" href="classbdm_1_1mDirich.html#a44230d127f95c6da1032e4e5886204ab" title="cache of beta_i">_beta</a>(<a class="code" href="classbdm_1_1mpdf__internal.html#a47bab632af15120c88aad647ae129468" title="Internal epdf used for sampling.">iepdf</a>.<a class="code" href="classbdm_1_1mDirich.html#a44230d127f95c6da1032e4e5886204ab" title="cache of beta_i">_beta</a>()){};
-<a name="l00368"></a><a class="code" href="classbdm_1_1mDirich.html#a78a06fc013ca7fc8dbc13ee899e3b0d0">00368</a>                 <span class="keywordtype">void</span> <a class="code" href="classbdm_1_1mDirich.html#a78a06fc013ca7fc8dbc13ee899e3b0d0" title="Update iepdf so that it represents this mpdf conditioned on rvc = cond This function...">condition</a> (<span class="keyword">const</span> vec &amp;val) {<a class="code" href="classbdm_1_1mDirich.html#a44230d127f95c6da1032e4e5886204ab" title="cache of beta_i">_beta</a> =  val/<a class="code" href="classbdm_1_1mDirich.html#acf9baed9baab754872ec59b9d45bf164" title="constant  of the random walk">k</a>+<a class="code" href="classbdm_1_1mDirich.html#a0c367b11fc853db86e9f00143e68013a" title="stabilizing coefficient ">betac</a>; };
+<a name="l00368"></a><a class="code" href="classbdm_1_1mDirich.html#a78a06fc013ca7fc8dbc13ee899e3b0d0">00368</a>                 <span class="keywordtype">void</span> <a class="code" href="classbdm_1_1mDirich.html#a78a06fc013ca7fc8dbc13ee899e3b0d0">condition</a> (<span class="keyword">const</span> vec &amp;val) {<a class="code" href="classbdm_1_1mDirich.html#a44230d127f95c6da1032e4e5886204ab" title="cache of beta_i">_beta</a> =  val/<a class="code" href="classbdm_1_1mDirich.html#acf9baed9baab754872ec59b9d45bf164" title="constant  of the random walk">k</a>+<a class="code" href="classbdm_1_1mDirich.html#a0c367b11fc853db86e9f00143e68013a" title="stabilizing coefficient ">betac</a>; };
 <a name="l00381"></a><a class="code" href="classbdm_1_1mDirich.html#ac1e6f42277b97f700ea1b6045cb6b2d7">00381</a>                 <span class="keywordtype">void</span> <a class="code" href="classbdm_1_1mDirich.html#ac1e6f42277b97f700ea1b6045cb6b2d7">from_setting</a> (<span class="keyword">const</span> Setting &amp;<span class="keyword">set</span>) {
 <a name="l00382"></a>00382                         <a class="code" href="classbdm_1_1mDirich.html#ac1e6f42277b97f700ea1b6045cb6b2d7">mpdf::from_setting</a> (<span class="keyword">set</span>); <span class="comment">// reads rv and rvc</span>
@@ -369,5 +369,5 @@
 <a name="l00451"></a>00451                         <span class="keywordflow">if</span> (<a class="code" href="classbdm_1_1BM.html#afaff0ad12556fe7dc0e2807d4fd938ee" title="If true, the filter will compute likelihood of the data record and store it in ll...">evalll</a>) {<a class="code" href="classbdm_1_1BMEF.html#a06e7b3ac03e10017d4288c76888e2865" title="cached value of lognc() in the previous step (used in evaluation of ll )">last_lognc</a> = <a class="code" href="classbdm_1_1multiBM.html#a9ecc6878abbd20eb8d8e43b6ab3f941a" title="Conjugate prior and posterior.">est</a>.<a class="code" href="classbdm_1_1eDirich.html#a279a99f6266c82fe2273e83841f19eb2" title="logarithm of the normalizing constant, ">lognc</a>();}
 <a name="l00452"></a>00452                 }
-<a name="l00454"></a><a class="code" href="classbdm_1_1multiBM.html#a31ff93f89473f099e489b9e1dc8d9513">00454</a>                 <span class="keyword">const</span> <a class="code" href="classbdm_1_1eDirich.html" title="Dirichlet posterior density.">eDirich</a>&amp; <a class="code" href="classbdm_1_1multiBM.html#a31ff93f89473f099e489b9e1dc8d9513" title="reimplemnetation of BM::posterior()">posterior</a>()<span class="keyword"> const </span>{<span class="keywordflow">return</span> <a class="code" href="classbdm_1_1multiBM.html#a9ecc6878abbd20eb8d8e43b6ab3f941a" title="Conjugate prior and posterior.">est</a>;};
+<a name="l00454"></a><a class="code" href="classbdm_1_1multiBM.html#a31ff93f89473f099e489b9e1dc8d9513">00454</a>                 <span class="keyword">const</span> <a class="code" href="classbdm_1_1eDirich.html" title="Dirichlet posterior density.">eDirich</a>&amp; <a class="code" href="classbdm_1_1multiBM.html#a31ff93f89473f099e489b9e1dc8d9513" title="return correctly typed posterior (covariant return)">posterior</a>()<span class="keyword"> const </span>{<span class="keywordflow">return</span> <a class="code" href="classbdm_1_1multiBM.html#a9ecc6878abbd20eb8d8e43b6ab3f941a" title="Conjugate prior and posterior.">est</a>;};
 <a name="l00456"></a><a class="code" href="classbdm_1_1multiBM.html#a7a480eace4446661bacca94c57499f01">00456</a>                 <span class="keywordtype">void</span> <a class="code" href="classbdm_1_1multiBM.html#a7a480eace4446661bacca94c57499f01" title="constructor function">set_parameters</a> (<span class="keyword">const</span> vec &amp;beta0) {
 <a name="l00457"></a>00457                         <a class="code" href="classbdm_1_1multiBM.html#a9ecc6878abbd20eb8d8e43b6ab3f941a" title="Conjugate prior and posterior.">est</a>.set_parameters (beta0);
@@ -451,5 +451,5 @@
 <a name="l00592"></a>00592                 }
 <a name="l00594"></a>00594 
-<a name="l00595"></a><a class="code" href="classbdm_1_1euni.html#acaa07b8307bd793d5339d6583e0aba81">00595</a>                 <span class="keywordtype">double</span> <a class="code" href="classbdm_1_1euni.html#acaa07b8307bd793d5339d6583e0aba81" title="Compute log-probability of argument val In case the argument is out of suport return...">evallog</a> (<span class="keyword">const</span> vec &amp;val)<span class="keyword"> const  </span>{
+<a name="l00595"></a><a class="code" href="classbdm_1_1euni.html#acaa07b8307bd793d5339d6583e0aba81">00595</a>                 <span class="keywordtype">double</span> <a class="code" href="classbdm_1_1euni.html#acaa07b8307bd793d5339d6583e0aba81">evallog</a> (<span class="keyword">const</span> vec &amp;val)<span class="keyword"> const  </span>{
 <a name="l00596"></a>00596                         <span class="keywordflow">if</span> (any (val &lt; <a class="code" href="classbdm_1_1euni.html#aff7ce6a2ef5ef0015bbd1398bed12f32" title="lower bound on support">low</a>) &amp;&amp; any (val &gt; <a class="code" href="classbdm_1_1euni.html#acfad2dea4a62db6872bda8abd75f0de1" title="upper bound on support">high</a>)) {<span class="keywordflow">return</span> inf;}
 <a name="l00597"></a>00597                         <span class="keywordflow">else</span> <span class="keywordflow">return</span> <a class="code" href="classbdm_1_1euni.html#a3e63be48dd58659663ca60cd18700476" title="cache of log( nk )">lnk</a>;
@@ -543,5 +543,5 @@
 <a name="l00724"></a><a class="code" href="classbdm_1_1mgnorm.html#a1b014915d74470d3efab74e07cacb97d">00724</a>                 <a class="code" href="classbdm_1_1mgnorm.html#a1b014915d74470d3efab74e07cacb97d" title="default constructor">mgnorm</a>() : <a class="code" href="classbdm_1_1mpdf__internal.html" title="Mpdf with internal epdf that is modified by function condition.">mpdf_internal</a>&lt;<a class="code" href="classbdm_1_1enorm.html" title="Gaussian density with positive definite (decomposed) covariance matrix.">enorm</a>&lt;sq_T&gt; &gt;() { }
 <a name="l00726"></a>00726                 <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classbdm_1_1mgnorm.html#ab736332d20e418bf50d45836e129f339" title="set mean function">set_parameters</a> (<span class="keyword">const</span> <a class="code" href="classbdm_1_1shared__ptr.html">shared_ptr&lt;fnc&gt;</a> &amp;g0, <span class="keyword">const</span> sq_T &amp;R0);
-<a name="l00727"></a>00727                 <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classbdm_1_1mgnorm.html#ab31d63472cf6a1030cd8dbd8094c1f6d" title="Update iepdf so that it represents this mpdf conditioned on rvc = cond This function...">condition</a> (<span class="keyword">const</span> vec &amp;cond);
+<a name="l00727"></a>00727                 <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classbdm_1_1mgnorm.html#ab31d63472cf6a1030cd8dbd8094c1f6d">condition</a> (<span class="keyword">const</span> vec &amp;cond);
 <a name="l00728"></a>00728 
 <a name="l00729"></a>00729 
@@ -619,5 +619,5 @@
 <a name="l00843"></a>00843                 <span class="keywordtype">void</span> <a class="code" href="classbdm_1_1mgamma.html#aa0f21c2557b233a85838b497d040ab14" title="Set value of k.">set_parameters</a> (<span class="keywordtype">double</span> <a class="code" href="classbdm_1_1mgamma.html#ab20cf88cca1fe9b0b8f2a412608bfd09" title="Constant .">k</a>, <span class="keyword">const</span> vec &amp;beta0);
 <a name="l00844"></a>00844 
-<a name="l00845"></a><a class="code" href="classbdm_1_1mgamma.html#a8996500f1885e39cde30221b20900bff">00845</a>                 <span class="keywordtype">void</span> <a class="code" href="classbdm_1_1mgamma.html#a8996500f1885e39cde30221b20900bff" title="Update iepdf so that it represents this mpdf conditioned on rvc = cond This function...">condition</a> (<span class="keyword">const</span> vec &amp;val) {<a class="code" href="classbdm_1_1mgamma.html#a3d95f4dde9214ff6dba265e18af60312" title="cache of iepdf.beta">_beta</a> = <a class="code" href="classbdm_1_1mgamma.html#ab20cf88cca1fe9b0b8f2a412608bfd09" title="Constant .">k</a> / val;};
+<a name="l00845"></a><a class="code" href="classbdm_1_1mgamma.html#a8996500f1885e39cde30221b20900bff">00845</a>                 <span class="keywordtype">void</span> <a class="code" href="classbdm_1_1mgamma.html#a8996500f1885e39cde30221b20900bff">condition</a> (<span class="keyword">const</span> vec &amp;val) {<a class="code" href="classbdm_1_1mgamma.html#a3d95f4dde9214ff6dba265e18af60312" title="cache of iepdf.beta">_beta</a> = <a class="code" href="classbdm_1_1mgamma.html#ab20cf88cca1fe9b0b8f2a412608bfd09" title="Constant .">k</a> / val;};
 <a name="l00857"></a><a class="code" href="classbdm_1_1mgamma.html#ada2af0f327e5452bee71d1bf97452ae4">00857</a>                 <span class="keywordtype">void</span> <a class="code" href="classbdm_1_1mgamma.html#ada2af0f327e5452bee71d1bf97452ae4">from_setting</a> (<span class="keyword">const</span> Setting &amp;<span class="keyword">set</span>) {
 <a name="l00858"></a>00858                         <a class="code" href="classbdm_1_1mgamma.html#ada2af0f327e5452bee71d1bf97452ae4">mpdf::from_setting</a> (<span class="keyword">set</span>); <span class="comment">// reads rv and rvc</span>
@@ -658,5 +658,5 @@
 <a name="l00909"></a>00909                         <a class="code" href="classbdm_1_1mpdf.html#a7c1900976ff13dbc09c9729b3bbff9e6" title="dimension of the condition">dimc</a> = dimension();
 <a name="l00910"></a>00910                 };
-<a name="l00911"></a><a class="code" href="classbdm_1_1migamma.html#a7a34b1e2e3aa2250d7c0ed7df1665b8c">00911</a>                 <span class="keywordtype">void</span> <a class="code" href="classbdm_1_1migamma.html#a7a34b1e2e3aa2250d7c0ed7df1665b8c" title="Update iepdf so that it represents this mpdf conditioned on rvc = cond This function...">condition</a> (<span class="keyword">const</span> vec &amp;val) {
+<a name="l00911"></a><a class="code" href="classbdm_1_1migamma.html#a7a34b1e2e3aa2250d7c0ed7df1665b8c">00911</a>                 <span class="keywordtype">void</span> <a class="code" href="classbdm_1_1migamma.html#a7a34b1e2e3aa2250d7c0ed7df1665b8c">condition</a> (<span class="keyword">const</span> vec &amp;val) {
 <a name="l00912"></a>00912                         <a class="code" href="classbdm_1_1migamma.html#a0d854c047001b5465cf1ba21f52904b5" title="cache of iepdf.beta">_beta</a> = elem_mult (val, (<a class="code" href="classbdm_1_1migamma.html#ac9847093da59a9ba0ebb68d2c592f5dc" title="cache of iepdf.alpha">_alpha</a> - 1.0));
 <a name="l00913"></a>00913                 };
@@ -677,5 +677,5 @@
 <a name="l00943"></a>00943                 };
 <a name="l00944"></a>00944 
-<a name="l00945"></a><a class="code" href="classbdm_1_1mgamma__fix.html#a1d539591deb7a38bb3403c2b396c8ff7">00945</a>                 <span class="keywordtype">void</span> <a class="code" href="classbdm_1_1mgamma__fix.html#a1d539591deb7a38bb3403c2b396c8ff7" title="Update iepdf so that it represents this mpdf conditioned on rvc = cond This function...">condition</a> (<span class="keyword">const</span> vec &amp;val) {vec mean = elem_mult (<a class="code" href="classbdm_1_1mgamma__fix.html#a018c6f901a04e419455308a07eb3b0b2" title="reference vector">refl</a>, pow (val, <a class="code" href="classbdm_1_1mgamma__fix.html#a1eb701506aabb2e6af007e487212d6fa" title="parameter l">l</a>)); <a class="code" href="classbdm_1_1mgamma.html#a3d95f4dde9214ff6dba265e18af60312" title="cache of iepdf.beta">_beta</a> = <a class="code" href="classbdm_1_1mgamma.html#ab20cf88cca1fe9b0b8f2a412608bfd09" title="Constant .">k</a> / mean;};
+<a name="l00945"></a><a class="code" href="classbdm_1_1mgamma__fix.html#a1d539591deb7a38bb3403c2b396c8ff7">00945</a>                 <span class="keywordtype">void</span> <a class="code" href="classbdm_1_1mgamma__fix.html#a1d539591deb7a38bb3403c2b396c8ff7">condition</a> (<span class="keyword">const</span> vec &amp;val) {vec mean = elem_mult (<a class="code" href="classbdm_1_1mgamma__fix.html#a018c6f901a04e419455308a07eb3b0b2" title="reference vector">refl</a>, pow (val, <a class="code" href="classbdm_1_1mgamma__fix.html#a1eb701506aabb2e6af007e487212d6fa" title="parameter l">l</a>)); <a class="code" href="classbdm_1_1mgamma.html#a3d95f4dde9214ff6dba265e18af60312" title="cache of iepdf.beta">_beta</a> = <a class="code" href="classbdm_1_1mgamma.html#ab20cf88cca1fe9b0b8f2a412608bfd09" title="Constant .">k</a> / mean;};
 <a name="l00946"></a>00946 };
 <a name="l00947"></a>00947 
@@ -695,7 +695,7 @@
 <a name="l00977"></a>00977                 };
 <a name="l00978"></a>00978 
-<a name="l00979"></a><a class="code" href="classbdm_1_1migamma__ref.html#aae86b2e4ff963d62e05d4e130514634a">00979</a>                 <span class="keywordtype">void</span> <a class="code" href="classbdm_1_1migamma__ref.html#aae86b2e4ff963d62e05d4e130514634a" title="Update iepdf so that it represents this mpdf conditioned on rvc = cond This function...">condition</a> (<span class="keyword">const</span> vec &amp;val) {
+<a name="l00979"></a><a class="code" href="classbdm_1_1migamma__ref.html#aae86b2e4ff963d62e05d4e130514634a">00979</a>                 <span class="keywordtype">void</span> <a class="code" href="classbdm_1_1migamma__ref.html#aae86b2e4ff963d62e05d4e130514634a">condition</a> (<span class="keyword">const</span> vec &amp;val) {
 <a name="l00980"></a>00980                         vec mean = elem_mult (<a class="code" href="classbdm_1_1migamma__ref.html#a3692dc67caf4367e15564d37f45476f6" title="reference vector">refl</a>, pow (val, <a class="code" href="classbdm_1_1migamma__ref.html#acdc1345ba8375fbdb18a69322d2f841d" title="parameter l">l</a>));
-<a name="l00981"></a>00981                         <a class="code" href="classbdm_1_1migamma__ref.html#aae86b2e4ff963d62e05d4e130514634a" title="Update iepdf so that it represents this mpdf conditioned on rvc = cond This function...">migamma::condition</a> (mean);
+<a name="l00981"></a>00981                         <a class="code" href="classbdm_1_1migamma__ref.html#aae86b2e4ff963d62e05d4e130514634a">migamma::condition</a> (mean);
 <a name="l00982"></a>00982                 };
 <a name="l00983"></a>00983 
@@ -737,5 +737,5 @@
 <a name="l01051"></a>01051                 };
 <a name="l01052"></a>01052 
-<a name="l01053"></a><a class="code" href="classbdm_1_1mlognorm.html#a9106d8fd8bdf2b6be675ffd8f3ca584e">01053</a>                 <span class="keywordtype">void</span> <a class="code" href="classbdm_1_1mlognorm.html#a9106d8fd8bdf2b6be675ffd8f3ca584e" title="Update iepdf so that it represents this mpdf conditioned on rvc = cond This function...">condition</a> (<span class="keyword">const</span> vec &amp;val) {
+<a name="l01053"></a><a class="code" href="classbdm_1_1mlognorm.html#a9106d8fd8bdf2b6be675ffd8f3ca584e">01053</a>                 <span class="keywordtype">void</span> <a class="code" href="classbdm_1_1mlognorm.html#a9106d8fd8bdf2b6be675ffd8f3ca584e">condition</a> (<span class="keyword">const</span> vec &amp;val) {
 <a name="l01054"></a>01054                         <a class="code" href="classbdm_1_1mlognorm.html#a7d0063f77d899ef22e8c5edd642176d2" title="access">mu</a> = log (val) - <a class="code" href="classbdm_1_1mlognorm.html#aa51128a2e503b8b2ce698244b9e0db1a" title="parameter 1/2*sigma^2">sig2</a>;<span class="comment">//elem_mult ( refl,pow ( val,l ) );</span>
 <a name="l01055"></a>01055                 };
@@ -806,5 +806,5 @@
 <a name="l01149"></a>01149                         <a class="code" href="classbdm_1_1eiWishartCh.html#ac6b684b52dc62b8d46e67d5992f98b9a" title="Internal instance of Wishart density.">W</a>.<a class="code" href="classbdm_1_1eWishartCh.html#a4eee757c0535c2a88bb20f0767c64981" title="fast access function y0 will be copied into Y.Ch.">setY</a> (iCh);
 <a name="l01150"></a>01150                 }
-<a name="l01151"></a><a class="code" href="classbdm_1_1eiWishartCh.html#aa6ddbd815b8b666dd542e97f009f89bb">01151</a>                 <span class="keyword">virtual</span> <span class="keywordtype">double</span> <a class="code" href="classbdm_1_1eiWishartCh.html#aa6ddbd815b8b666dd542e97f009f89bb" title="Compute log-probability of argument val In case the argument is out of suport return...">evallog</a> (<span class="keyword">const</span> vec &amp;val)<span class="keyword"> const </span>{
+<a name="l01151"></a><a class="code" href="classbdm_1_1eiWishartCh.html#aa6ddbd815b8b666dd542e97f009f89bb">01151</a>                 <span class="keyword">virtual</span> <span class="keywordtype">double</span> <a class="code" href="classbdm_1_1eiWishartCh.html#aa6ddbd815b8b666dd542e97f009f89bb">evallog</a> (<span class="keyword">const</span> vec &amp;val)<span class="keyword"> const </span>{
 <a name="l01152"></a>01152                         <a class="code" href="classbdm_1_1chmat.html" title="Symmetric matrix stored in square root decomposition using upper cholesky.">chmat</a> X (<a class="code" href="classbdm_1_1eiWishartCh.html#ac11f1c41183f743b97fbb73a4e9ba6cd" title="size of Ch">p</a>);
 <a name="l01153"></a>01153                         <span class="keyword">const</span> <a class="code" href="classbdm_1_1chmat.html" title="Symmetric matrix stored in square root decomposition using upper cholesky.">chmat</a>&amp; Y = <a class="code" href="classbdm_1_1eiWishartCh.html#ac6b684b52dc62b8d46e67d5992f98b9a" title="Internal instance of Wishart density.">W</a>.<a class="code" href="classbdm_1_1eWishartCh.html#a1708cacb5d8cb1b96395d35f5327cb7e" title="access function">getY</a>();
@@ -851,5 +851,5 @@
 <a name="l01200"></a>01200                         <a class="code" href="classbdm_1_1mpdf.html#a7c1900976ff13dbc09c9729b3bbff9e6" title="dimension of the condition">dimc</a> = <a class="code" href="classbdm_1_1mpdf__internal.html#a47bab632af15120c88aad647ae129468" title="Internal epdf used for sampling.">iepdf</a>.<a class="code" href="classbdm_1_1epdf.html#a7083a65f7b7a0d0d13b2c516bd2ec29c" title="Size of the random variable.">dimension</a>();
 <a name="l01201"></a>01201                 }
-<a name="l01202"></a><a class="code" href="classbdm_1_1rwiWishartCh.html#aac087ba6c885d3faeda9171229f9b4e6">01202</a>                 <span class="keywordtype">void</span> <a class="code" href="classbdm_1_1rwiWishartCh.html#aac087ba6c885d3faeda9171229f9b4e6" title="Update iepdf so that it represents this mpdf conditioned on rvc = cond This function...">condition</a> (<span class="keyword">const</span> vec &amp;c) {
+<a name="l01202"></a><a class="code" href="classbdm_1_1rwiWishartCh.html#aac087ba6c885d3faeda9171229f9b4e6">01202</a>                 <span class="keywordtype">void</span> <a class="code" href="classbdm_1_1rwiWishartCh.html#aac087ba6c885d3faeda9171229f9b4e6">condition</a> (<span class="keyword">const</span> vec &amp;c) {
 <a name="l01203"></a>01203                         vec z = c;
 <a name="l01204"></a>01204                         <span class="keywordtype">int</span> ri = 0;
@@ -1040,5 +1040,5 @@
 <a name="l01419"></a>01419 <span class="keyword"></span>{
 <a name="l01420"></a>01420         <a class="code" href="bdmerror_8h.html#a7a3399d182b8e3065532596e76f84849" title="Throw std::runtime_exception if t is not true.">bdm_assert</a> (<a class="code" href="classbdm_1_1epdf.html#ac4b863ff84c7a4882fb3ad18556027f9" title="True if rv is assigned.">isnamed</a>(), <span class="stringliteral">&quot;rv description is not assigned&quot;</span>);
-<a name="l01421"></a>01421         ivec irvn = rvn.<a class="code" href="classbdm_1_1RV.html#acbebdb5e0d30101a6eb63550ef701c55" title="when this rv is a part of bigger rv, this function returns indices of self in the...">dataind</a> (<a class="code" href="classbdm_1_1epdf.html#a62c5b8ff71d9ebe6cd58d3c342eb1dc8" title="Description of the random variable.">rv</a>);
+<a name="l01421"></a>01421         ivec irvn = rvn.<a class="code" href="classbdm_1_1RV.html#acbebdb5e0d30101a6eb63550ef701c55">dataind</a> (<a class="code" href="classbdm_1_1epdf.html#a62c5b8ff71d9ebe6cd58d3c342eb1dc8" title="Description of the random variable.">rv</a>);
 <a name="l01422"></a>01422 
 <a name="l01423"></a>01423         sq_T Rn (<a class="code" href="classbdm_1_1enorm.html#a2d92dde696b2a7a5b10ddef5d22ba2c2" title="Covariance matrix in decomposed form.">R</a>, irvn);  <span class="comment">// select rows and columns of R</span>
@@ -1068,6 +1068,6 @@
 <a name="l01447"></a>01447         <a class="code" href="bdmerror_8h.html#a7a3399d182b8e3065532596e76f84849" title="Throw std::runtime_exception if t is not true.">bdm_assert</a> ( (rvc.<a class="code" href="classbdm_1_1RV.html#ade30156104f61d86c94f758861418089" title="total size of a random variable">_dsize</a>() + rvn.<a class="code" href="classbdm_1_1RV.html#ade30156104f61d86c94f758861418089" title="total size of a random variable">_dsize</a>() == <a class="code" href="classbdm_1_1epdf.html#a62c5b8ff71d9ebe6cd58d3c342eb1dc8" title="Description of the random variable.">rv</a>.<a class="code" href="classbdm_1_1RV.html#ade30156104f61d86c94f758861418089" title="total size of a random variable">_dsize</a>()), <span class="stringliteral">&quot;wrong rvn&quot;</span>);
 <a name="l01448"></a>01448         <span class="comment">//Permutation vector of the new R</span>
-<a name="l01449"></a>01449         ivec irvn = rvn.<a class="code" href="classbdm_1_1RV.html#acbebdb5e0d30101a6eb63550ef701c55" title="when this rv is a part of bigger rv, this function returns indices of self in the...">dataind</a> (<a class="code" href="classbdm_1_1epdf.html#a62c5b8ff71d9ebe6cd58d3c342eb1dc8" title="Description of the random variable.">rv</a>);
-<a name="l01450"></a>01450         ivec irvc = rvc.<a class="code" href="classbdm_1_1RV.html#acbebdb5e0d30101a6eb63550ef701c55" title="when this rv is a part of bigger rv, this function returns indices of self in the...">dataind</a> (<a class="code" href="classbdm_1_1epdf.html#a62c5b8ff71d9ebe6cd58d3c342eb1dc8" title="Description of the random variable.">rv</a>);
+<a name="l01449"></a>01449         ivec irvn = rvn.<a class="code" href="classbdm_1_1RV.html#acbebdb5e0d30101a6eb63550ef701c55">dataind</a> (<a class="code" href="classbdm_1_1epdf.html#a62c5b8ff71d9ebe6cd58d3c342eb1dc8" title="Description of the random variable.">rv</a>);
+<a name="l01450"></a>01450         ivec irvc = rvc.<a class="code" href="classbdm_1_1RV.html#acbebdb5e0d30101a6eb63550ef701c55">dataind</a> (<a class="code" href="classbdm_1_1epdf.html#a62c5b8ff71d9ebe6cd58d3c342eb1dc8" title="Description of the random variable.">rv</a>);
 <a name="l01451"></a>01451         ivec perm = concat (irvn , irvc);
 <a name="l01452"></a>01452         sq_T Rn (<a class="code" href="classbdm_1_1enorm.html#a2d92dde696b2a7a5b10ddef5d22ba2c2" title="Covariance matrix in decomposed form.">R</a>, perm);
@@ -1099,5 +1099,5 @@
 <a name="l01480"></a>01480 
 <a name="l01481"></a>01481 <span class="keyword">template</span>&lt;<span class="keyword">class</span> sq_T&gt;
-<a name="l01482"></a><a class="code" href="classbdm_1_1mgnorm.html#ab31d63472cf6a1030cd8dbd8094c1f6d">01482</a> <span class="keywordtype">void</span> <a class="code" href="classbdm_1_1mgnorm.html#ab31d63472cf6a1030cd8dbd8094c1f6d" title="Update iepdf so that it represents this mpdf conditioned on rvc = cond This function...">mgnorm&lt;sq_T &gt;::condition</a> (<span class="keyword">const</span> vec &amp;cond) {this-&gt;<a class="code" href="classbdm_1_1mpdf__internal.html#a47bab632af15120c88aad647ae129468" title="Internal epdf used for sampling.">iepdf</a>._mu() = g-&gt;eval (cond);};
+<a name="l01482"></a><a class="code" href="classbdm_1_1mgnorm.html#ab31d63472cf6a1030cd8dbd8094c1f6d">01482</a> <span class="keywordtype">void</span> <a class="code" href="classbdm_1_1mgnorm.html#ab31d63472cf6a1030cd8dbd8094c1f6d">mgnorm&lt;sq_T &gt;::condition</a> (<span class="keyword">const</span> vec &amp;cond) {this-&gt;<a class="code" href="classbdm_1_1mpdf__internal.html#a47bab632af15120c88aad647ae129468" title="Internal epdf used for sampling.">iepdf</a>._mu() = g-&gt;eval (cond);};
 <a name="l01483"></a>01483 
 <a name="l01485"></a>01485 <span class="keyword">template</span>&lt;<span class="keyword">class</span> sq_T&gt;
@@ -1113,5 +1113,5 @@
 <a name="l01495"></a>01495 <span class="preprocessor">#endif //EF_H</span>
 </pre></div></div>
-<hr size="1"/><address style="text-align: right;"><small>Generated on Mon Oct 12 19:37:19 2009 for mixpp by&nbsp;
+<hr size="1"/><address style="text-align: right;"><small>Generated on Thu Oct 15 00:07:48 2009 for mixpp by&nbsp;
 <a href="http://www.doxygen.org/index.html">
 <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.6.1 </small></address>