Index: library/tests/emix_test.cpp
===================================================================
--- library/tests/emix_test.cpp (revision 693)
+++ library/tests/emix_test.cpp (revision 713)
@@ -68,8 +68,8 @@
 
 	int N = 3;
-	mat Smp = M2.sample_m ( N );
+	mat Smp = M2.sample_mat ( N );
 
 	vec exp_ll ( "-5.0 -2.53563 -2.62171" );
-	vec ll = M2.evallog_m ( Smp );
+	vec ll = M2.evallog_mat ( Smp );
 	CHECK_CLOSE ( exp_ll, ll, 5.0 );
 
@@ -115,5 +115,5 @@
 	Array<vec> actual(CurrentContext::max_trial_count);
 	do {
-		mat smp = distrib_obj.sample_m ( nsamples );
+		mat smp = distrib_obj.sample_mat ( nsamples );
 		vec emu = sum ( smp, 2 ) / nsamples;
 		actual( tc ) = emu;
@@ -135,5 +135,5 @@
 	Array<mat> actual(CurrentContext::max_trial_count);
 	do {
-		mat smp = distrib_obj.sample_m ( nsamples );
+		mat smp = distrib_obj.sample_mat ( nsamples );
 		vec emu = sum ( smp, 2 ) / nsamples;
 		mat er = ( smp * smp.T() ) / nsamples - outer_product ( emu, emu );
Index: library/tests/merger_2d_test.cpp
===================================================================
--- library/tests/merger_2d_test.cpp (revision 693)
+++ library/tests/merger_2d_test.cpp (revision 713)
@@ -58,6 +58,6 @@
 	emix* MP = MM.epredictor(); //xy
 
-	vec Res1 = M.evallog_m ( Grid );
-	mat Res2 = ( MP )->evallog_M ( Grid );
+	vec Res1 = M.evallog_mat ( Grid );
+	mat Res2 = ( MP )->evallog_mat ( Grid );
 
 	it_file it ( "merger_2d_test.it" );
@@ -66,6 +66,6 @@
 	it << Name ( "Res1" ) << Res1;
 	it << Name ( "Res2" ) << Res2;
-	it << Name ( "S1" ) << f1->evallog_m ( Grid );
-	it << Name ( "S2" ) << f2->evallog_m ( Grid );
+	it << Name ( "S1" ) << f1->evallog_mat ( Grid );
+	it << Name ( "S2" ) << f2->evallog_mat ( Grid );
 	cout << ( ( enorm<ldmat>* ) ( MP->_Coms ( 0 ).get() ) )->_R().to_mat() << endl;
 }
Index: library/tests/emix.cfg
===================================================================
--- library/tests/emix.cfg (revision 713)
+++ library/tests/emix.cfg (revision 713)
@@ -0,0 +1,25 @@
+data = (
+{
+  class = "pdf_harness";
+  pdf = {
+    class = "emix";
+    pdfs = ( 
+    {
+		class = "enorm<ldmat>";
+		mu = [ 1.5 1.7 ];
+		R = ( "matrix", 2, 2, [ 1.2, 0.3, 0.3, 5 ] );
+    },
+    {
+		class = "egamma";
+		alpha = [ 100000 10000 ];
+		beta = [ 10000 1000 ];	
+    });
+    weights = [ 0.5, 0.5 ];
+  };
+  mean = [ 1.5 1.7 ];
+  R = ( "matrix", 2, 2, [ 1.27572, 0.778247, 0.778247, 3.33129 ] );
+# TODO CO S TIM? R, variance
+  variance = [ 1.2, 5.0 ];
+  tolerance = 0.1;
+});
+
Index: library/tests/pdf_harness.cpp
===================================================================
--- library/tests/pdf_harness.cpp (revision 706)
+++ library/tests/pdf_harness.cpp (revision 713)
@@ -50,5 +50,5 @@
 	Array<vec> actual(CurrentContext::max_trial_count);
 	do {
-		mat smp = hpdf->samplecond_m ( cond, nsamples );
+		mat smp = hpdf->samplecond_mat ( cond, nsamples );
 		vec emu = smp * ones ( nsamples ) / nsamples;
 		actual( tc ) = emu;
@@ -71,5 +71,5 @@
 	Array<mat> actual(CurrentContext::max_trial_count);
 	do {
-		mat smp = hpdf->samplecond_m ( cond, nsamples );
+		mat smp = hpdf->samplecond_mat ( cond, nsamples );
 		vec emu = smp * ones ( nsamples ) / nsamples;
 		mat er = ( smp * smp.T() ) / nsamples - outer_product ( emu, emu );
Index: library/tests/pdf_test.cpp
===================================================================
--- library/tests/pdf_test.cpp (revision 706)
+++ library/tests/pdf_test.cpp (revision 713)
@@ -13,8 +13,4 @@
 static void check_covariance(mmix &distrib_obj, const vec &mu0, int nsamples, const mat &R, double tolerance);
 
-TEST ( mepdf_test ) {
-	pdf_harness::test_config ( "mepdf.cfg" );
-}
-
 TEST ( mgamma_test ) {
 	pdf_harness::test_config ( "mgamma.cfg" );
@@ -29,6 +25,9 @@
 }
 
-// not using pdf_harness because mmix isn't configurable (yet?)
 TEST ( mmix_test ) {
+	pdf_harness::test_config ( "mmix.cfg" );
+	//vec tmu = 0.5 * eN->mean() + 0.5 * mu0;
+
+	/*
 	RV x ( "{mmixx }", "2" );
 	RV y ( "{mmixy }", "2" );
@@ -63,8 +62,11 @@
 	mat observedR ( "1.27572 0.778247; 0.778247 3.33129" );
 	check_covariance( mMix, mu0, N, observedR, 0.2 );
+*/
 }
 
 // not using pdf_harness because emix isn't configurable (yet?)
-TEST ( mepdf_emix_test ) {
+TEST ( emix_test ) {
+	pdf_harness::test_config ( "emix.cfg" );
+	/*
 	int N = 10000; //number of samples
 	vec mu0 ( "1.5 1.7" );
@@ -87,4 +89,5 @@
 	eMix->set_parameters ( vec_2 ( 0.5, 0.5 ), Coms );
 	check_mean ( *eMix, mu0, N, eMix->mean(), 0.1 );
+	*/
 }
 
@@ -93,5 +96,5 @@
 	Array<vec> actual(CurrentContext::max_trial_count);
 	do {
-		mat smp = distrib_obj.samplecond_m ( mu0, nsamples );
+		mat smp = distrib_obj.samplecond_mat ( mu0, nsamples );
 		vec emu = smp * ones ( nsamples ) / nsamples ;
 		actual( tc ) = emu;
@@ -113,5 +116,5 @@
 	Array<mat> actual(CurrentContext::max_trial_count);
 	do {
-		mat smp = distrib_obj.samplecond_m ( mu0, nsamples );
+		mat smp = distrib_obj.samplecond_mat ( mu0, nsamples );
 		vec emu = smp * ones ( nsamples ) / nsamples ;
 		mat er = ( smp * smp.T() ) / nsamples - outer_product ( emu, emu );
Index: library/tests/merger_test.cpp
===================================================================
--- library/tests/merger_test.cpp (revision 693)
+++ library/tests/merger_test.cpp (revision 713)
@@ -29,6 +29,6 @@
 	x_grid.set_row ( 0, linspace ( -10.0, 10.0 ) );
 
-	vec l_f1 = f1->evallog_m ( x_grid );
-	vec l_f2 = f2->evallog_m ( x_grid );
+	vec l_f1 = f1->evallog_mat ( x_grid );
+	vec l_f2 = f2->evallog_mat ( x_grid );
 	mat lW ( 2, Npoints );
 	lW.set_row ( 0, l_f1 );
Index: library/tests/CMakeLists.txt
===================================================================
--- library/tests/CMakeLists.txt (revision 700)
+++ library/tests/CMakeLists.txt (revision 713)
@@ -41,5 +41,5 @@
 # using UnitTest++
 
-SET(unit_test_configurations  egiw.cfg mlnorm.cfg edirich.cfg mprod.cfg generator.cfg epdfds.cfg pdfds.cfg test_user_info_input.cfg merger.cfg erroneous.cfg egamma.cfg test_user_info_external.cfg merger_error.cfg mgamma.cfg enorm.cfg)
+SET(unit_test_configurations  egiw.cfg mlnorm.cfg edirich.cfg mprod.cfg generator.cfg epdfds.cfg pdfds.cfg test_user_info_input.cfg merger.cfg erroneous.cfg egamma.cfg test_user_info_external.cfg merger_error.cfg mgamma.cfg enorm.cfg mmix.cfg emix.cfg)
 
 add_executable(testsuite arx_straux_test.cpp datalink_test.cpp  datasource_test.cpp egiw_test.cpp emix_test.cpp epdf_test.cpp logger_test.cpp LQG_test.cpp merger_test.cpp 
Index: library/tests/epdf_harness.cpp
===================================================================
--- library/tests/epdf_harness.cpp (revision 706)
+++ library/tests/epdf_harness.cpp (revision 713)
@@ -95,5 +95,5 @@
 		}
 
-		vec lpzv_act = hepdf->evallog_m ( zero1n );
+		vec lpzv_act = hepdf->evallog_mat ( zero1n );
 		CHECK_CLOSE_EX ( lpzv, lpzv_act, tolerance );
 
@@ -105,5 +105,5 @@
 		}
 
-		lpzv_act = hepdf->evallog_m ( zeroa );
+		lpzv_act = hepdf->evallog_mat ( zeroa );
 		CHECK_CLOSE_EX ( lpzv, lpzv_act, tolerance );
 	}
@@ -162,5 +162,5 @@
 	Array<vec> actual(CurrentContext::max_trial_count);
 	do {
-		mat smp = hepdf->sample_m ( nsamples );
+		mat smp = hepdf->sample_mat ( nsamples );
 		vec emu = smp * ones ( nsamples ) / nsamples;
 		actual( tc ) = emu;
@@ -183,5 +183,5 @@
 	Array<mat> actual(CurrentContext::max_trial_count);
 	do {
-		mat smp = hepdf->sample_m ( nsamples );
+		mat smp = hepdf->sample_mat ( nsamples );
 		vec emu = smp * ones ( nsamples ) / nsamples;
 		mat er = ( smp * smp.T() ) / nsamples - outer_product ( emu, emu );
@@ -208,5 +208,5 @@
 	Array<vec> actual(CurrentContext::max_trial_count);
 	do {
-		mat smp = mep.samplecond_m ( vec ( 0 ), nsamples );
+		mat smp = mep.samplecond_mat ( vec ( 0 ), nsamples );
 		vec emu = sum ( smp, 2 ) / nsamples;
 		actual( tc ) = emu;
@@ -229,5 +229,5 @@
 	Array<mat> actual(CurrentContext::max_trial_count);
 	do {
-		mat smp = mep.samplecond_m ( vec ( 0 ), nsamples );
+		mat smp = mep.samplecond_mat ( vec ( 0 ), nsamples );
 		vec emu = sum ( smp, 2 ) / nsamples;
 		mat er = ( smp * smp.T() ) / nsamples - outer_product ( emu, emu );
Index: library/tests/merger_iter_test.cpp
===================================================================
--- library/tests/merger_iter_test.cpp (revision 693)
+++ library/tests/merger_iter_test.cpp (revision 713)
@@ -60,6 +60,6 @@
 	epdf* MP = MM.epredictor();//xy
 
-	vec Res1 = M.evallog_m ( Grid );
-	mat Res2 = ( ( emix* ) MP )->evallog_M ( Grid );
+	vec Res1 = M.evallog_mat ( Grid );
+	mat Res2 = ( ( emix* ) MP )->evallog_mat ( Grid );
 
 	it_file it ( "merger_iter_test.it" );
Index: library/tests/mixtures_test.cpp
===================================================================
--- library/tests/mixtures_test.cpp (revision 679)
+++ library/tests/mixtures_test.cpp (revision 713)
@@ -69,5 +69,5 @@
 	// Sample parameters
 	int ndat = 100;
-	mat Smp = Simul.sample_m ( ndat );
+	mat Smp = Simul.sample_mat ( ndat );
 
 	cout << "Simulated means: " << m1 << " and " << m2 << endl;
Index: library/tests/arx_elem_test.cpp
===================================================================
--- library/tests/arx_elem_test.cpp (revision 682)
+++ library/tests/arx_elem_test.cpp (revision 713)
@@ -38,6 +38,6 @@
 
 	mlstudent* Ap = Ar.predictor_student();
-	vec Ap_x = Ap->evallogcond_m ( X, empty_vec );
-	vec ll_x = Ar.logpred_m ( X2 );
+	vec Ap_x = Ap->evallogcond_mat ( X, empty_vec );
+	vec ll_x = Ar.logpred_mat ( X2 );
 
 	cout << "normalize : " << xstep*sum ( exp ( Ap_x ) ) << endl;